﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace EDU05Demo
{
    public partial class Form1 : Form
    {
        bool LCD_Cleared;

        public Form1()
        {
            InitializeComponent();
        }

        [DllImport("edu05d.dll")]
        public static extern int OpenDevice();

        [DllImport("edu05d.dll")]
        public static extern void CloseDevice();

        [DllImport("edu05d.dll")]
		public static extern  bool Connected();

		[DllImport("edu05d.dll")]
		public static extern int ReadAnalogChannel(int Channel);

		[DllImport("edu05d.dll")]
		 public static extern int ReadAllDigital();

		[DllImport("edu05d.dll")]
		public static extern void SetPWM(int Channel, int Data);

		[DllImport("edu05d.dll")]
		public static extern void InOutMode(int IOMode);
		
		[DllImport("edu05d.dll")]
		public static extern void OutputAllDigital(int Data);

		[DllImport("edu05d.dll")]
		public static extern void ClearAllDigital();

		[DllImport("edu05d.dll")]
		public static extern void SetAllDigital();

		[DllImport("edu05d.dll")]
		public static extern void ClearDigitalChannel(int Channel);

		[DllImport("edu05d.dll")]
		public static extern void SetDigitalChannel(int Channel);

		[DllImport("edu05d.dll")]
		public static extern void LCDInit();

		[DllImport("edu05d.dll")]
		public static extern void LCDClear();

		[DllImport("edu05d.dll")]
		public static extern void LCDWriteString(string Data, int Position);

        private void Button1_Click(object sender, EventArgs e)
        {
            int h = OpenDevice();
            switch (h)
            {
                case 0:
                    Label1.Text = "EDU05 not found";
                    break;
                case 1:
                    Label1.Text = "EDU05 connected";
                    Timer1.Enabled = true;
                    break;
            }
        }

        private void Timer1_Tick(object sender, EventArgs e)
        {
            int i;
            int[] Buffer = new int[5];
            Timer1.Enabled = false;

            if (Connected())
                Label1.Text = "EDU05 connected";
            else
                Label1.Text = "EDU05 not connected";

			InOutMode(1);			// input mode
            for (i = 0; i < 5; i++)
                Buffer[i] = ReadAnalogChannel(i + 1);

			i = ReadAllDigital();
			InOutMode(0);			// output mode

			switch (i)
			{
				case 1:
					textBox1.Text = "Button = SW1    ";
					SetDigitalChannel(1);
					panel1.BackColor = Color.FromArgb(255, 128, 0);
					break;
				case 2:
					textBox1.Text = "Button = SW2    ";
					SetDigitalChannel(2);
					panel2.BackColor = Color.FromArgb(255, 128, 0);
					break;
				case 4:
					textBox1.Text = "RV1 = "+Convert.ToInt32(Buffer[0]*100/1023).ToString()+"% ";
					SetDigitalChannel(3);
					panel3.BackColor = Color.FromArgb(255, 128, 0);
					break;
				case 8:
					textBox1.Text = "RV2 = "+Convert.ToInt32(Buffer[1]*100/1023).ToString()+"% ";
					SetDigitalChannel(4);
					panel4.BackColor = Color.FromArgb(255, 128, 0);
					break;
				case 16:
					textBox1.Text = "Temp. = "+Convert.ToInt32((Buffer[2]-155)*10/31).ToString()+"°C ";
					SetDigitalChannel(5);
					panel5.BackColor = Color.FromArgb(255, 128, 0);
					break;
				case 32:
					if (Buffer[3] > 0)
						textBox1.Text = "NTC = "+Convert.ToInt32((1023-Buffer[3])*10000/Buffer[3]).ToString()+"ohm ";
					SetDigitalChannel(6);
					panel6.BackColor = Color.FromArgb(255, 128, 0);
					break;
				case 64:
					if (Buffer[4] > 0)
						textBox1.Text = "LDR = "+Convert.ToInt32((1023-Buffer[4])*10000/Buffer[4]).ToString()+"ohm ";
					SetDigitalChannel(7);
					panel7.BackColor = Color.FromArgb(255, 128, 0);
					break;
				case 128:
					textBox1.Text = "Button = SW8    ";
					SetDigitalChannel(8);
					panel8.BackColor = Color.FromArgb(255, 128, 0);
					break;
				default:
					textBox1.Text = "";
					ClearAllDigital();
					panel1.BackColor = Color.LightGray;
					panel2.BackColor = Color.LightGray;
					panel3.BackColor = Color.LightGray;
					panel4.BackColor = Color.LightGray;
					panel5.BackColor = Color.LightGray;
					panel6.BackColor = Color.LightGray;
					panel7.BackColor = Color.LightGray;
					panel8.BackColor = Color.LightGray;
					break;
			}			
			
			if (textBox1.Text == "")
			{
                if (!LCD_Cleared)
                {
                    LCDClear();
                    LCD_Cleared = true;
                }
			}
			else
			{
				LCDWriteString(textBox1.Text,0);
				LCD_Cleared = false;
			}

            Timer1.Enabled = true;
        }

        private void button6_Click(object sender, EventArgs e)
        {
            CloseDevice();
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            CloseDevice();
        }

    


    }
}
