﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace EDU05Demo
{
    public partial class Form1 : Form
    {
        int IOMode;

        public Form1()
        {
            InitializeComponent();
        }

        [DllImport("edu05d.dll")]
        public static extern int OpenDevice();

        [DllImport("edu05d.dll")]
        public static extern void CloseDevice();

        [DllImport("edu05d.dll")]
		public static extern  bool Connected();

		[DllImport("edu05d.dll")]
		public static extern int ReadAnalogChannel(int Channel);

		[DllImport("edu05d.dll")]
		 public static extern int ReadAllDigital();

		[DllImport("edu05d.dll")]
		public static extern void SetPWM(int Channel, int Data);

		[DllImport("edu05d.dll")]
		public static extern void InOutMode(int IOMode);
		
		[DllImport("edu05d.dll")]
		public static extern void OutputAllDigital(int Data);

		[DllImport("edu05d.dll")]
		public static extern void ClearAllDigital();

		[DllImport("edu05d.dll")]
		public static extern void SetAllDigital();

		[DllImport("edu05d.dll")]
		public static extern void ClearDigitalChannel(int Channel);

		[DllImport("edu05d.dll")]
		public static extern void SetDigitalChannel(int Channel);

		[DllImport("edu05d.dll")]
		public static extern void LCDInit();

		[DllImport("edu05d.dll")]
		public static extern void LCDClear();

		[DllImport("edu05d.dll")]
		public static extern void LCDWriteString(string Data, int Position);

        private void Button1_Click(object sender, EventArgs e)
        {
            int h = OpenDevice();
            switch (h)
            {
                case 0:
                    Label1.Text = "EDU05 not found";
                    break;
                case 1:
                    Label1.Text = "EDU05 connected";
                    IOMode = 1;
                    InOutMode(IOMode);
                    RadioButton3.Checked = true;
                    Timer1.Enabled = true;
                    break;
            }
        }

        private void Timer1_Tick(object sender, EventArgs e)
        {
            int i;
            int[] Buffer = new int[5];
            Timer1.Enabled = false;

            if (Connected())
                Label1.Text = "EDU05 connected";
            else
                Label1.Text = "EDU05 not connected";

            for (i = 0; i < 5; i++)
                Buffer[i] = ReadAnalogChannel(i + 1);

            ProgressBar1.Value = Buffer[0];
            Label4.Text = Buffer[0].ToString();
            ProgressBar2.Value = Buffer[1];
            Label5.Text = Buffer[1].ToString();
            ProgressBar3.Value = Buffer[2];
            Label7.Text = Buffer[2].ToString();
            ProgressBar4.Value = Buffer[3];
            Label9.Text = Buffer[3].ToString();
            ProgressBar5.Value = Buffer[4];
            Label11.Text = Buffer[4].ToString();

            i = ReadAllDigital();
            CheckBox1.Checked = (i & 1) > 0;
            CheckBox2.Checked = (i & 2) > 0;
            CheckBox3.Checked = (i & 4) > 0;
            CheckBox4.Checked = (i & 8) > 0;
            CheckBox5.Checked = (i & 16) > 0;
            CheckBox6.Checked = (i & 32) > 0;
            CheckBox7.Checked = (i & 64) > 0;
            CheckBox8.Checked = (i & 128) > 0;

            Timer1.Enabled = true;
        }

        private void button6_Click(object sender, EventArgs e)
        {
            CloseDevice();
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            CloseDevice();
        }

        private void Button2_Click(object sender, EventArgs e)
        {
            IOMode = 0;
            InOutMode(IOMode);
            SetAllDigital();
            RadioButton4.Checked = true;
        }

        private void Button3_Click(object sender, EventArgs e)
        {
            IOMode = 0;
            InOutMode(IOMode);
            ClearAllDigital();
            RadioButton4.Checked = true;
        }

        private void button4_Click(object sender, EventArgs e)
        {
            InOutMode(0);
            LCDClear();
            InOutMode(IOMode);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            InOutMode(0);
			LCDWriteString(textBox1.Text,Convert.ToInt32(textBox2.Text));
			InOutMode(IOMode);
        }

        private void RadioButton3_CheckedChanged(object sender, EventArgs e)
        {
            IOMode = 1;
            InOutMode(IOMode);
        }

        private void RadioButton4_CheckedChanged(object sender, EventArgs e)
        {
            IOMode = 0;
            InOutMode(IOMode);
        }

        private void CheckBox1_CheckedChanged(object sender, EventArgs e)
        {
            if (IOMode == 0)
            {
                if (CheckBox1.Checked)
                    SetDigitalChannel(1);
                else
                    ClearDigitalChannel(1);
            }	
        }

        private void CheckBox2_CheckedChanged(object sender, EventArgs e)
        {
            if (IOMode == 0)
            {
                if (CheckBox2.Checked)
                    SetDigitalChannel(2);
                else
                    ClearDigitalChannel(2);
            }
        }

        private void CheckBox3_CheckedChanged(object sender, EventArgs e)
        {
            if (IOMode == 0)
            {
                if (CheckBox3.Checked)
                    SetDigitalChannel(3);
                else
                    ClearDigitalChannel(3);
            }
        }

        private void CheckBox4_CheckedChanged(object sender, EventArgs e)
        {
            if (IOMode == 0)
            {
                if (CheckBox4.Checked)
                    SetDigitalChannel(4);
                else
                    ClearDigitalChannel(4);
            }
        }

        private void CheckBox5_CheckedChanged(object sender, EventArgs e)
        {
            if (IOMode == 0)
            {
                if (CheckBox5.Checked)
                    SetDigitalChannel(5);
                else
                    ClearDigitalChannel(5);
            }
        }

        private void CheckBox6_CheckedChanged(object sender, EventArgs e)
        {
            if (IOMode == 0)
            {
                if (CheckBox6.Checked)
                    SetDigitalChannel(6);
                else
                    ClearDigitalChannel(6);
            }
        }

        private void CheckBox7_CheckedChanged(object sender, EventArgs e)
        {
            if (IOMode == 0)
            {
                if (CheckBox7.Checked)
                    SetDigitalChannel(7);
                else
                    ClearDigitalChannel(7);
            }
        }

        private void CheckBox8_CheckedChanged(object sender, EventArgs e)
        {
            if (IOMode == 0)
            {
                if (CheckBox8.Checked)
                    SetDigitalChannel(8);
                else
                    ClearDigitalChannel(8);
            }
        }

        private void TrackBar1_Scroll(object sender, EventArgs e)
        {
            SetPWM(1, TrackBar1.Value);
            Label15.Text = Convert.ToString(TrackBar1.Value);
        }

        private void TrackBar2_Scroll(object sender, EventArgs e)
        {
            SetPWM(2, TrackBar2.Value);
            Label16.Text = Convert.ToString(TrackBar2.Value);
        }


    }
}
